# procedimiento para calcular el centroide de una 
# imagen estelar.
#
# El script escanea el cursor de imagen hasta que se presiona
# cualquier tecla. A partir de las coordenadas aproximadas
# utiliza la tarea IMCNTR para calcular el centroide de la
# imagen.
#
# Se ingresa con el nombre de la imagen y el tamano de la
# caja de busqueda, y devuelve las coordenadas calculadas,
# las coordenadas aproximadas iniciales y la tecla presionada.
#
#
#
# Noviembre 2013
#

procedure centro (archin)
int    lado=5        {min=3, prompt="Size of extraction box"}

string archin        {prompt="image to process"}

struct *lista

begin
  string st1,st2,st3,comand,tecla
  string imag,tfile 
  int cenx,ceny,jj,sis,box
  real coox,cooy
      
# inicializa archivos y punteros

 imag=archin

# se asegura que la caja sea de dimension impar

  box=(lado/2)*2+1

# llama al bucle para leer coordenadas de imagen

  while(fscan(imcur,cenx,ceny,sis,comand) != EOF){ 
    tecla = substr(comand,1,1)
    if(tecla != " ")break
  }

# llama a IMCNTR para definir el centroide

  tfile = mktemp("./temp")
  imcntr(imag,cenx,ceny,cboxsize=box, >tfile)

# lee archivo de salida

  lista=tfile
  jj=fscan(lista,st1,st2,coox,st3,cooy)
  lista=""
  delete(tfile,ver-)

  printf("%.3f %.3f  %3d %3d %c\n",coox,cooy,cenx,ceny,tecla)

# salida
end
